package com.nisum.offertransactionservice.service;

import com.nisum.offertransactionservice.dao.EndOfSaleRepo;
import com.nisum.offertransactionservice.dto.EndOfSaleReq;
import com.nisum.offertransactionservice.model.*;
import lombok.extern.slf4j.Slf4j;
import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.util.*;

@Service
@Slf4j
public class EndOfSaleService {

    @Autowired
    private EndOfSaleRepo endOfSaleRepo;



    public String putEndofSaleResInDb(EndOfSaleReq endOfSaleReq) throws IOException {
        ObjectMapper mapper = new ObjectMapper();
        String offerTransactionResponseJson = mapper.writeValueAsString(endOfSaleReq.getOfferTransactionResponse());
        String offersJosn = mapper.writeValueAsString(endOfSaleReq.getOffers());
        EndOfSaleEntity endOfSaleEntity = new EndOfSaleEntity();
        endOfSaleEntity.setUuid(UUID.randomUUID());
        endOfSaleEntity.setOfferTransactionResponse(offerTransactionResponseJson);
        endOfSaleEntity.setOffers(offersJosn);
        endOfSaleRepo.save(endOfSaleEntity);
        if(Objects.nonNull(endOfSaleReq.getOfferTransactionResponse().getTransactionId()))
            return endOfSaleReq.getOfferTransactionResponse().getTransactionId();
        final String toString = endOfSaleEntity.getUuid().toString();
        return toString;
    }



}
